package
{
	import fl.controls.Button;
	import fl.controls.CheckBox;
	import fl.controls.ComboBox;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import fl.data.DataProvider;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.NetStatusEvent;
	import flash.events.StatusEvent;
	import flash.events.TimerEvent;
	import flash.media.Camera;
	import flash.media.Microphone;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.text.TextFieldAutoSize;
	import flash.utils.Timer;
	
	[SWF(width="640", height="480", backgroundColor="#FFFFFF", frameRate="24")]
	public class simpleRed5Recording extends Sprite
	{
		
		private var activeCamera:Camera;
		private var activeMic:Microphone;
		private var activeConnection:NetConnection;
		private var activeStream:NetStream;
		private var audioOnlyStream:NetStream;
		
		private var onScreenVideo:Video;
		private var audioPlaybackVideo:Video;
		
		private var camAllowed:Boolean = false;
		private var micAllowed:Boolean = false;
		private var recordingHalted:Boolean = false;
		private var currentlyRecordedFileName:String = "";
		
		private var bufferCheckTimer:Timer;
		
		// UI Purposes - These Controls come from the swc
		private var btnRecord:Button;
		private var btnPlay:Button;
		
		private var lblCameraSelection:Label;
		private var cbCameraSelection:ComboBox;
		
		private var lblMicSelection:Label;
		private var cbMicSelection:ComboBox;
		private var cbMicHz:ComboBox;
		private var lblMic:Label;
		
		private var lblVidPlaceholder:Label;
		private var lblVidResolution:Label;
		
		private var lblCamWidth:Label;
		private var txtCamWidth:TextInput;
		
		private var lblCamHeight:Label;
		private var txtCamHeight:TextInput;
		
		private var lblCamFPS:Label;
		private var txtCamFPS:TextInput;
		
		private var lblCamBandwidth:Label;
		private var txtCamBandwidth:TextInput;
		
		private var lblCamQuality:Label;
		private var txtCamQuality:TextInput;
		
		private var lblVideoBuffer:Label;
		
		private var lblMediaSvr:Label;
		private var txtMediaSvrAdd:TextInput;
		private var btnMediaSrvr:Button;
		private var lblBufferSize:Label;
		
		private var lblNetStreamBuff:Label;
		private var txtNetStreamBuff:TextInput;
		
		private var lblNetStreamBehavior:Label;
		private var cbNetStreamBehavior:CheckBox;
		
		private var lblRecordVideo:Label;
		private var cbRecordVideo:CheckBox;
		
		private var lblRecordAudio:Label;
		private var cbRecordAudio:CheckBox;
		
		private var lblStatus:Label;
		
		public function simpleRed5Recording()
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			// Setup the UI
			setupUI();
		}
		
		
		private function setupUI():void {
			
			onScreenVideo = new Video(320, 240);
			onScreenVideo.smoothing = true;
			onScreenVideo.x = 10;
			onScreenVideo.y = 10;
			
			// We smash the audio only video behind the real video that contains..well video. Audio video is only used for
			// playing back audio.
			
			// Make sure to set the video to the same size as your camera!
			// NAH - making it smaller and it will just get crushed
			audioPlaybackVideo = new Video(320, 240);
			audioPlaybackVideo.x = 10;
			audioPlaybackVideo.y = 10;
			
			addChild(audioPlaybackVideo); // -- This is directly behind the onScreenVideo so its not visible
			addChild(onScreenVideo);
			
			lblVidPlaceholder = new Label();
			lblVidPlaceholder.text = "Once You Record Video Wideo Will Be Displayed Here";
			lblVidPlaceholder.width = 200;
			lblVidPlaceholder.height = 100;
			lblVidPlaceholder.wordWrap = true;
			lblVidPlaceholder.x = 10;
			lblVidPlaceholder.y = 100;
			addChild(lblVidPlaceholder);
			
			lblMediaSvr = new Label();
			lblMediaSvr.text = "Media Server Application URI:";
			lblMediaSvr.width = 200;
			lblMediaSvr.x = 340;
			lblMediaSvr.y = 10;
			addChild(lblMediaSvr);
			
			txtMediaSvrAdd = new TextInput();
			txtMediaSvrAdd.text = "rtmp://localhost/vod";
			txtMediaSvrAdd.x = 340;
			txtMediaSvrAdd.y = 30;
			txtMediaSvrAdd.width = 160;
			addChild(txtMediaSvrAdd);
			
			btnMediaSrvr = new Button();
			btnMediaSrvr.label = "Connect";
			btnMediaSrvr.addEventListener(MouseEvent.CLICK, handleMedSrvrBtn, false, 0, true);
			btnMediaSrvr.x = 520;
			btnMediaSrvr.y = 30;
			addChild(btnMediaSrvr);
			
			lblVidResolution = new Label();
			lblVidResolution.text = "Settings Take Effect When You Connect to the Media Server In This Example. Disconnect then Re-connect to Change Camera and Microphone Settings.";
			lblVidResolution.wordWrap = true;
			lblVidResolution.width = 300;
			lblVidResolution.height = 200;
			//lblVidResolution.autoSize = TextFieldAutoSize.LEFT;
			lblVidResolution.x = 340;
			lblVidResolution.y = 60;
			addChild(lblVidResolution);
			
			
			lblCamWidth = new Label();
			lblCamWidth.text = "Width:";
			lblCamWidth.x = 340;
			lblCamWidth.y = 170;
			addChild(lblCamWidth);
			
			txtCamWidth = new TextInput();
			txtCamWidth.width = 35;
			txtCamWidth.height = 20;
			txtCamWidth.x = 375;
			txtCamWidth.y = 170;
			txtCamWidth.text = "640";
			addChild(txtCamWidth);
			
			lblCamHeight = new Label();
			lblCamHeight.text = "Height:";
			lblCamHeight.y = 170;
			lblCamHeight.x = 435;
			addChild(lblCamHeight);
			
			txtCamHeight = new TextInput();
			txtCamHeight.width = 35;
			txtCamHeight.height = 20;
			txtCamHeight.y = 170;
			txtCamHeight.x = 470;
			txtCamHeight.text = "480";
			addChild(txtCamHeight);
			
			lblCamFPS = new Label();
			lblCamFPS.text = "FPS:";
			lblCamFPS.y = 170;
			lblCamFPS.x = 525;
			addChild(lblCamFPS);
			
			txtCamFPS = new TextInput();
			txtCamFPS.width = 35;
			txtCamFPS.height = 20;
			txtCamFPS.x = 550;
			txtCamFPS.y = 170;
			txtCamFPS.text = "29.97";
			addChild(txtCamFPS);
			
			lblCamBandwidth = new Label();
			lblCamBandwidth.text = "Bandwidth:";
			lblCamBandwidth.x = 340;
			lblCamBandwidth.y = 200;
			lblCamBandwidth.width = 60;
			addChild( lblCamBandwidth );
			
			txtCamBandwidth = new TextInput();
			txtCamBandwidth.width = 30;
			txtCamBandwidth.height = 20;
			txtCamBandwidth.y = 200;
			txtCamBandwidth.x = 400;
			txtCamBandwidth.text = "0";
			addChild( txtCamBandwidth );
			
			lblCamQuality = new Label();
			lblCamQuality.text = "Quality:";
			lblCamQuality.x = 435;
			lblCamQuality.y = 200;
			lblCamQuality.width = 65;
			addChild( lblCamQuality );
			
			txtCamQuality = new TextInput();
			txtCamQuality.width = 30;
			txtCamQuality.height = 20;
			txtCamQuality.y = 200;
			txtCamQuality.x = 470;
			txtCamQuality.text = "85";
			addChild( txtCamQuality );
			
			lblMic = new Label();
			lblMic.text = "Microphone Record Rate";
			lblMic.width = 150;
			lblMic.x = 340;
			lblMic.y = 280;
			addChild(lblMic);
			
			var sampleRates:Array = [ 
				{label:"44kHz", data:"44"}, 
				{label:"22kHz", data:"22"}, 
				{label:"11kHz", data:"11" },
				{label:"8kHz", data:"8"}, 
				{label:"5kHz", data:"5"}
			]; 
			
			cbMicHz = new ComboBox();
			cbMicHz.dropdownWidth = 100;
			cbMicHz.move(340, 300);
			cbMicHz.dataProvider = new DataProvider(sampleRates);
			addChild(cbMicHz);
			
			// This grabs a system list of camera and mic data
			// There are a bunch of little dances you need to do in code to handle users unplugging
			// and plugging stuff in but we are not doing that on this example
			var Cams:Array = Camera.names;
			var Mics:Array = Microphone.names;
			
			var camData:Array = new Array();
			for(var i:int = 0; i < Cams.length; i++) {
				//camMicData.availableCameras.addItem({label:Cams[i], data:i});
				camData.push( {label:Cams[i], data:i} );
			}
			var micData:Array = new Array();
			for(i = 0; i < Mics.length; i++) {
				//camMicData.availableMicrophones.addItem({label:Mics[i], data:i});
				micData.push( {label:Mics[i], data:i} );
			}
			
			lblCameraSelection = new Label();
			lblCameraSelection.text = "Camera to Use:";
			lblCameraSelection.x = 340;
			lblCameraSelection.y = 120;
			addChild(lblCameraSelection);
			
			cbCameraSelection = new ComboBox();
			cbCameraSelection.dataProvider = new DataProvider(camData);
			cbCameraSelection.dropdownWidth = 175;
			cbCameraSelection.width = 175;
			cbCameraSelection.move(340, 140);
			addChild(cbCameraSelection);
			
			lblMicSelection = new Label();
			lblMicSelection.text = "Microphone to Use:";
			lblMicSelection.x = 340;
			lblMicSelection.y = 230;
			addChild(lblMicSelection);
			
			cbMicSelection = new ComboBox();
			cbMicSelection.dataProvider = new DataProvider(micData);
			cbMicSelection.dropdownWidth = 175;
			cbMicSelection.width = 175;
			cbMicSelection.move(340, 250);
			addChild(cbMicSelection);
			
			
			
			lblNetStreamBuff = new Label();
			lblNetStreamBuff.text = "Netstream Buffer Time During Recording (Automatically Set to 1 For Playback)";
			lblNetStreamBuff.x = 340;
			lblNetStreamBuff.y = 330;
			lblNetStreamBuff.width = 200;
			lblNetStreamBuff.height = 60;
			lblNetStreamBuff.wordWrap = true;
			addChild( lblNetStreamBuff );
			
			txtNetStreamBuff = new TextInput();
			txtNetStreamBuff.text = "60";
			txtNetStreamBuff.height = 20;
			txtNetStreamBuff.width = 30;
			txtNetStreamBuff.x = 340;
			txtNetStreamBuff.y = 365;
			addChild( txtNetStreamBuff );
			
			lblNetStreamBehavior = new Label();
			lblNetStreamBehavior.text = "Netstream Waits For Buffer To Empty Before Calling close?";
			lblNetStreamBehavior.width = 200;
			lblNetStreamBehavior.height = 60;
			lblNetStreamBehavior.wordWrap = true;
			lblNetStreamBehavior.x = 340;
			lblNetStreamBehavior.y = 385;
			addChild( lblNetStreamBehavior );
			
			cbNetStreamBehavior = new CheckBox();
			cbNetStreamBehavior.x = 340;
			cbNetStreamBehavior.y = 415;
			cbNetStreamBehavior.selected = true;
			cbNetStreamBehavior.label = "";
			addChild( cbNetStreamBehavior );
			
			// -- Left side UI
			btnRecord = new Button();
			btnRecord.label = "Record";
			btnRecord.addEventListener(MouseEvent.CLICK, handleRecordStartStop, false, 0, true);
			btnRecord.x = 10;
			btnRecord.y = 290;
			addChild(btnRecord);
			btnRecord.enabled = false;
			
			btnPlay = new Button();
			btnPlay.label = "Play Recording";
			btnPlay.addEventListener(MouseEvent.CLICK, handlePlaybackClick, false, 0, true);
			btnPlay.x = 200;
			btnPlay.y = 290;
			addChild(btnPlay);
			btnPlay.enabled = false;
			
			lblVideoBuffer = new Label();
			lblVideoBuffer.text = "Netstream Buffer: 0";
			lblVideoBuffer.x = 10;
			lblVideoBuffer.y = 250;
			lblVideoBuffer.width = 320;
			addChild(lblVideoBuffer);
			
			lblStatus = new Label();
			lblStatus.x = 10;
			lblStatus.y = 360;
			lblStatus.width = 320;
			lblStatus.height = 120;
			lblStatus.wordWrap = true;
			setStatus("Setting up UI:");
			addChild(lblStatus);
			
			lblRecordVideo = new Label();
			lblRecordVideo.x = 10;
			lblRecordVideo.y = 320;
			lblRecordVideo.width = 100;
			lblRecordVideo.text = "Record Video? ";
			addChild(lblRecordVideo);
			
			cbRecordVideo = new CheckBox();
			cbRecordVideo.x = 90;
			cbRecordVideo.y = 320;
			cbRecordVideo.selected = true;
			cbRecordVideo.label = "";
			cbRecordVideo.addEventListener(Event.CHANGE, handleRecordCBStreamChange, false, 0, true);
			addChild( cbRecordVideo );
			
			lblRecordAudio = new Label();
			lblRecordAudio.x = 120;
			lblRecordAudio.y = 320;
			lblRecordAudio.width = 100;
			lblRecordAudio.text = "Record Audio? ";
			addChild(lblRecordAudio);
			
			cbRecordAudio = new CheckBox();
			cbRecordAudio.x = 200;
			cbRecordAudio.y = 320;
			cbRecordAudio.selected = true;
			cbRecordAudio.label = "";
			cbRecordAudio.addEventListener(Event.CHANGE, handleRecordCBStreamChange, false, 0, true);
			addChild( cbRecordAudio );
		}
		
		/**
		 * Just a utility function for the UI
		 * @param	_OnOff
		 */
		private function disableEnableRecordingSettings(_OnOff:Boolean):void {
			if (_OnOff == true) {
				
				txtMediaSvrAdd.enabled = true;
				txtCamWidth.enabled = true;
				txtCamHeight.enabled = true;
				txtCamFPS.enabled = true;
				txtCamBandwidth.enabled = true;
				txtCamQuality.enabled = true;
				cbMicHz.enabled = true;
				txtNetStreamBuff.enabled = true;
				cbNetStreamBehavior.enabled = true;
				cbCameraSelection.enabled = true;
				cbMicSelection.enabled = true;
				
			} else {
				
				txtMediaSvrAdd.enabled = false;
				txtCamWidth.enabled = false;
				txtCamHeight.enabled = false;
				txtCamFPS.enabled = false;
				txtCamBandwidth.enabled = false;
				txtCamQuality.enabled = false;
				cbMicHz.enabled = false;
				txtNetStreamBuff.enabled = false;
				cbNetStreamBehavior.enabled = false;
				cbCameraSelection.enabled = false;
				cbMicSelection.enabled = false;
			}
		}
		
		/**
		 * Another utility function for the UI. Changes the status text in the lower left
		 * @param	_NewStatus
		 */
		private function setStatus(_NewStatus:String):void {
			lblStatus.text = "STATUS: " + _NewStatus;
		}
		
		/**
		 * Mouse Click Event button handler for connect/Disconnect to the media server
		 * (The button in the top left)
		 * @param	e
		 */
		private function handleMedSrvrBtn(e:MouseEvent):void {
			if (btnMediaSrvr.label == "Connect") {
				
				// Disable UI recording settings
				disableEnableRecordingSettings(false);
				
				setupConnection();
				
				btnMediaSrvr.label = "Disconnect";
			} else {
				
				// Destroy the camera
				destroyBufferCheckTimer();
				// Destroy camera and mic
				destroyCameraAndMic();
				// Destroy any leftover or active streams
				destroyStreams();
				// Destroy the original connection
				destroyConnection();
				
				// Enable UI recording settings
				disableEnableRecordingSettings(true);
				
				btnRecord.enabled = false;
				btnPlay.enabled = false;
				
				btnMediaSrvr.label = "Connect";
			}
		}
		
		/**
		 * The mouse click event handler for the recording start/stop button
		 * @param	e
		 */
		private function handleRecordStartStop(e:MouseEvent):void {
			if (btnRecord.label == "Record") {
				
				recordingHalted = false;
				
				lblVidPlaceholder.visible = false;
				setupStream();
				setupCameraAndMic();
				
				btnPlay.label = "Play Recording";
				btnPlay.enabled = false;
				
				btnRecord.label = "Stop";
			} else {
				
				if (activeStream != null) {
					setStatus("Done recording, waiting for buffers to empty.");
					
					activeStream.attachCamera(null);
					activeStream.attachAudio(null);
					
					// In Red5 1.0.2 Snapshot this causes another stream to start message
					// You dont do this on FMS anyway
					//activeStream.publish("false");
					//audioOnlyStream.publish("false");
					
					recordingHalted = true;
					
					// Looks like we aren't waiting for the buffer to empty. Good luck!
					if (cbNetStreamBehavior.selected == false) {
						destroyBufferCheckTimer();
						activeStream.close();
						
						setStatus("We didn't wait for the buffers to empty and immediateley closed.");
						// OK - Enable Playback - playback time
						btnPlay.enabled = true;
					}
					
				}
				
				btnRecord.label = "Record";
			}
		}
		
		/**
		 * The mouse click handler for the button that allows you to play back a recording.
		 * @param	e
		 */
		private function handlePlaybackClick(e:MouseEvent):void {
			if (btnPlay.label == "Play Recording") {
				
				doRecordingPlayback();
				
				btnPlay.label = "Stop";
			} else {
				
				stopRecordingPlayback();
				
				btnPlay.label = "Play Recording";
			}
		}
		/**
		 * We have to ensure at least one or both check boxes are
		 * always checked
		 */
		private function handleRecordCBStreamChange(e:Event):void {
			
			if(cbRecordAudio.selected == false && cbRecordVideo.selected == false) {
				if( CheckBox( e.target ).selected == false ) {
					CheckBox( e.target ).selected = true;
				}
			}
		}
		/**
		 * This function is envoked by the media server when transcoding completes..if using the 
		 * recording_merger application.
		 * 
		 * @param	_FullFilePath
		 */
		public function transcodingCallback(_FullFilePath:String):void {
			setStatus("transcodingCallback Final Video at: " + _FullFilePath);
		}
		
		/**
		 * Sets up the Netconnection to the media server
		 */
		private function setupConnection():void {
			if(activeConnection == null) {
				activeConnection = new NetConnection();
				// Setting the client to this so when the server attempts to call functions on the client
				// it will go to this class.
				activeConnection.client = this;
				activeConnection.addEventListener(NetStatusEvent.NET_STATUS, handleConnectionStatus, false, 0, true);
				activeConnection.connect( txtMediaSvrAdd.text );
				setStatus("Connecting to: " + txtMediaSvrAdd.text );
			} else {
				destroyConnection(true);
			}
		}
		
		/**
		 * A utility function for destroying the active netconnection object.
		 * 
		 * Please ignore the optionalCallback items, they are just a methodology I use
		 * @param	_OptionalCallback
		 */
		private function destroyConnection(_OptionalCallback:Boolean = false):void {
			if (activeConnection != null) {
				
				activeConnection.close();
				activeConnection.removeEventListener(NetStatusEvent.NET_STATUS, handleConnectionStatus);
				activeConnection = null;
				
				if (_OptionalCallback == true) {
					setupConnection();
				}
			}
		}
		
		/**
		 * The NetConnections netstatus event handler.  This will fire when a connection is closed
		 * or if you successfully connect to a media server.
		 * @param	e
		 */
		private function handleConnectionStatus(e:NetStatusEvent):void {
			trace("handleConnectionStatus - " + e.info.code );
			switch(e.info.code) {
				case 'NetConnection.Connect.Success':
					setStatus("Successfully connected to: " + txtMediaSvrAdd.text );
					btnRecord.enabled = true;
					
					break;
				case 'NetConnection.Connect.Closed':
					setStatus("Netconnection Closed to: " + txtMediaSvrAdd.text );
					break;
			}
		}
		
		/**
		 * This function begins setup on the audio and video netstream which are part of the
		 * core of recording and playback when dealing with a media server.
		 */
		private function setupStream():void {
			if (activeStream == null) {
				activeStream = new NetStream(activeConnection);
				
				// Set the client object so the netstreams can call onMetaData when we do playback
				activeStream.client = this;
				
				activeStream.addEventListener(NetStatusEvent.NET_STATUS, handleStreamStatus, false, 0, true);
				//audioOnlyStream.addEventListener(NetStatusEvent.NET_STATUS, handleAudioOnlyStreamStatus, false, 0, true);
				// Set the buffer time real high so the player doesnt just start dropping frames all over the place
				// to preserve the tiny default .1 buffer
				// http://livedocs.adobe.com/flash/9.0/ActionScriptLangRefV3/flash/net/NetStream.html#bufferTime
				activeStream.bufferTime = Number( txtNetStreamBuff.text );
			} else {
				destroyStreams(true);
			}
		}
		
		/**
		 * Just a function for cleaning up any of the Netstreams as completley as possible.
		 * Again, ignore the optional callback stuff. Its just a methodology I use in OO programming.
		 * @param	_OptionalCallback
		 */
		private function destroyStreams(_OptionalCallback:Boolean = false):void {
			if (activeStream != null) {
				
				if(onScreenVideo != null) {
					onScreenVideo.attachNetStream(null);
				}
				if(audioPlaybackVideo != null) {
					audioPlaybackVideo.attachNetStream(null);
				}
				
				activeStream.attachCamera(null);
				activeStream.attachAudio(null);
				
				activeStream.close();
				
				activeStream.removeEventListener(NetStatusEvent.NET_STATUS, handleStreamStatus);
				
				activeStream = null;
				audioOnlyStream = null;
				
				if (_OptionalCallback == true) {
					setupStream();
				}
			}
		}
		
		// When streaming video or doing playback using netstream you always have to setup onMetaData
		// so this is used for both AUDIO and VIDEO
		// Where we set the netstream's client to this, it allows the netstream to automatically call this function
		public function onMetaData(info:Object):void {
			trace("playback called onMetaData");
			setStatus("Playback of recording called onMetaData");
		}
		
		// Also a callback needed when streaming video back
		// http://livedocs.adobe.com/flash/9.0/ActionScriptLangRefV3/flash/net/NetStream.html#event:onPlayStatus
		public function onPlayStatus(info:Object):void {
			trace("playback called onPlayStatus");
			setStatus("Playback of recording called onPlayStatus");
		}
		
		/**
		 * Handles NetStatus events on the video NetStream
		 * We dont particularly do anything here, but these are real helpful
		 * if making a full video player.
		 * @param	e
		 */
		private function handleStreamStatus(e:NetStatusEvent):void {
			trace("handleStreamStatus " + e.info.code);
			switch(e.info.code) {
				case 'NetStream.Buffer.Empty':
					setStatus("Video Netstream Buffer Empty");
					break;
				case 'NetStream.Buffer.Full':
					setStatus("Video Netstream Buffer Full");
					break;
				case 'NetStream.Buffer.Flush':
					setStatus("Video Netstream Buffer Flushed!!!!");
					break;
				case 'NetStream.Unpublish.Success':
					setStatus("Netstream Unpublish Success");
					break;
			}
		}
		
		/**
		 * Handles NetStatus events on the audio NetStream
		 * We dont particularly do anything here, but these are real helpful
		 * if making a full video player.
		 * @param	e
		 */
		private function handleAudioOnlyStreamStatus(e:NetStatusEvent):void {
			trace("handleAudioOnlyStreamStatus " + e.info.code);
			switch(e.info.code) {
				case 'NetStream.Buffer.Empty':
					setStatus("Audio Netstream Buffer Empty");
					break;
				case 'NetStream.Buffer.Full':
					setStatus("Audio Netstream Buffer Full");
					break;
				case 'NetStream.Buffer.Flush':
					setStatus("Audio Netstream Buffer Flushed!!!");
					break;
				case 'NetStream.Unpublish.Success':

					break;
			}
		}
		
		/**
		 * Prepares the camera and microphone based on the parameters in the UI.
		 */
		private function setupCameraAndMic():void {
			if (activeCamera == null) {
				// Gets the default camera on the system - you can pass "0", "1", etc to manually select devices
				activeCamera = Camera.getCamera( String(cbCameraSelection.selectedItem.data) );
				activeCamera.addEventListener(StatusEvent.STATUS, handleCameraStatus, false, 0, true);
				// 320x240 at 20fps
				activeCamera.setMode( int( txtCamWidth.text ) , int( txtCamHeight.text ) , Number( txtCamFPS.text ) );
				// Youll probably have to set quality lower depending on your webcam.  All webcams transmit different
				// ammounts of data. Theyll get the buffer so high it's impractical for users to wait that long!
				activeCamera.setQuality( int( txtCamBandwidth.text ) , int( txtCamQuality.text ) );
				
				activeMic = Microphone.getMicrophone( int( cbMicSelection.selectedItem.data ) );
				activeMic.addEventListener(StatusEvent.STATUS, handleMicrophoneStatus, false, 0, true);
				// Rate in khz
				// http://livedocs.adobe.com/flash/9.0/ActionScriptLangRefV3/flash/media/Microphone.html#rate
				activeMic.rate = int( cbMicHz.selectedItem.data  );
				activeMic.gain = 50;
				// Audio wont transmit all the time causing breaks in recorded audio stream screwing up the
				// flv.  Make sure even if its silence while recording the mic is always sending data
				activeMic.setSilenceLevel(0);
				
				if(contains(onScreenVideo)) removeChild(onScreenVideo);
				onScreenVideo = null;
				onScreenVideo = new Video(320,240);
				onScreenVideo.smoothing = true;
				onScreenVideo.x = 10;
				onScreenVideo.y = 10;
				addChild(onScreenVideo);
				
				onScreenVideo.attachCamera(activeCamera);
				if (activeStream != null) {
					if(cbRecordAudio.selected == true) {
						activeStream.attachAudio(activeMic);
					}
					if(cbRecordVideo.selected == true) {
						activeStream.attachCamera(activeCamera);
					}
				}
				
				// Wait for the security settings - If we have already approved these - the fun little dialog wont ever show up again,
				// and the events on camera and mic wont fire, so just check initially.
				setStatus("Waiting for camera and microphone security settings.");
				
				// -- Will just proceede to publish recording if we already have passed security settings
				finishCamAndMicSetup();
			} else {
				destroyCameraAndMic(true);
			}
		}
		
		/**
		 * A utility function for completley cleaning up the camrea and microphone
		 * @param	_OptionalCallback
		 */
		private function destroyCameraAndMic(_OptionalCallback:Boolean = false):void {
			if (activeCamera != null) {
				
				if ( onScreenVideo != null) {
					onScreenVideo.attachCamera(null);
				}
				
				if (activeStream != null) {
					activeStream.attachCamera(null);
				}
				
				if (audioOnlyStream != null) {
					audioOnlyStream.attachAudio(null);
				}
				
				activeCamera.removeEventListener(StatusEvent.STATUS, handleCameraStatus);
				activeCamera = null;
				
				activeMic.removeEventListener(StatusEvent.STATUS, handleMicrophoneStatus);
				activeMic = null;
				
				// Just in case - will do nothing if already destroyed
				destroyBufferCheckTimer();
				
				if (_OptionalCallback == true) {
					setupCameraAndMic();
				}
			}
		}
		
		/**
		 * We have to wait to actually start recording due to the Flash Player security
		 * dialog. So this method is called only after we have the OK on security settings.
		 */
		private function finishCamAndMicSetup():void {
			if (camAllowed == true && micAllowed == true) {
				if (activeStream != null) {
					
					setStatus("Recording....");
					
					// This will start recording - the name we specify here is the name of the final file
					// on the server.
					// I'll use the data functionality to generate unique names
					var tempDate:Date = new Date();
					var uniqueFileName:String = "RecordTest_" + String(tempDate.getMinutes()) + String(tempDate.getMilliseconds());
					
					currentlyRecordedFileName = uniqueFileName;
					
					// OK lets start recording - look in the "streams" directory inside of red5
					// inside of the app we connected to in the NetConnection
					activeStream.publish(uniqueFileName, "record");
					
					// Immediateley send some metadata to try and avoid backward timestamp bug in FMS 4.5
					//http://helpx.adobe.com/adobe-media-server/kb/custom-metadata-added-live-stream.html
					// If not, may cause FLVs not to play back
					//
					// ALSO on Red5 1.0.2 Snapshot this can cause flvs not to play back initially too..so send over some metadata
					var myMetaDataObj:Object = new Object();
					myMetaDataObj.AuthoritativeID = "Technogumbo";
					myMetaDataObj.codec = activeStream.videoStreamSettings.codec;
					//if(dataHolder.useH264) {
					//	myMetaDataObj.profile = h264Settings.profile;
					//	myMetaDataObj.level = h264Settings.level;
					//}
					
					activeStream.send("@setDataFrame", "onMetaData", myMetaDataObj);
					
					createBufferCheckTimer();
				}
			}
		}
		
		/**
		 * Utility function for creating the timer that checks the netstreams buffer.
		 * This timer executes every 100 milliseconds, or 10 times a second because 1000ms = 1 second
		 */
		private function createBufferCheckTimer():void {
			if (bufferCheckTimer == null) {
				bufferCheckTimer = new Timer(100);
				bufferCheckTimer.addEventListener(TimerEvent.TIMER, handleBufferCheck, false, 0, true);
				bufferCheckTimer.start();
			} else {
				destroyBufferCheckTimer(true);
			}
		}
		
		/**
		 * Utility function for destroying the buffer check timer.
		 * @param	_OptionalCallback
		 */
		private function destroyBufferCheckTimer(_OptionalCallback:Boolean = false):void {
			if (bufferCheckTimer != null) {
				bufferCheckTimer.stop();
				bufferCheckTimer.removeEventListener(TimerEvent.TIMER, handleBufferCheck);
				bufferCheckTimer = null;
				
				if (_OptionalCallback == true) {
					createBufferCheckTimer();
				}
			}
		}
		
		/**
		 * Whenever the timer runs, this function is called, so its called 10 times a second
		 * to check the state of the buffers when recording.
		 * @param	e
		 */
		private function handleBufferCheck(e:TimerEvent):void {
			if (activeStream != null) {
				
				if (lblVideoBuffer != null) {
					lblVideoBuffer.text = "Video Stream Buffer: " + String( activeStream.bufferLength );
				}
				
				if (recordingHalted == true) {
					if ( (activeStream.bufferLength == 0) ) {
						activeStream.close();
						
						bufferCheckTimer.stop();
						bufferCheckTimer.removeEventListener(TimerEvent.TIMER, handleBufferCheck);
						bufferCheckTimer = null;
						
						setStatus("Buffers Empty. Press 'Play Recording' to start playback.");
						// OK - Enable Playback - playback time
						btnPlay.enabled = true;
					}
				}
			}
			
			if (bufferCheckTimer != null) {
				bufferCheckTimer.reset();
				bufferCheckTimer.start();
			}
		}
		
		/**
		 * The flash player security dialog will prompt users for camera access when we request the camera
		 * use this event to figure out if they allowed it or not.
		 * http://livedocs.adobe.com/flash/9.0/ActionScriptLangRefV3/flash/media/Camera.html#getCamera%28%29
		 * @param	e
		 */
		private function handleCameraStatus(e:StatusEvent):void {
			trace("handleCameraStatus - " + e.code);
			switch(e.code) {
				case 'Camera.muted':
					// Show a message
					setStatus("Camera muted - unable to continue");
					break;
				case 'Camera.Unmuted':
					camAllowed = true;
					finishCamAndMicSetup();
					break;
			}
		}
		
		/**
		 * The flash player security dialog will prompt users for microphone access when we request the camera
		 * use this event to figure out if they allowed it or not.
		 * http://livedocs.adobe.com/flash/9.0/ActionScriptLangRefV3/flash/media/Camera.html#getCamera%28%29
		 * @param	e
		 */
		private function handleMicrophoneStatus(e:StatusEvent):void {
			trace("handleMicrophoneStatus - " + e.code);
			switch(e.code) {
				case 'Microphone.Muted':
					// Show a message
					setStatus("Microphone muted - unable to continue");
					break;
				case 'Microphone.Unmuted':
					micAllowed = true;
					finishCamAndMicSetup();
					break;
			}
		}
		
		/**
		 * When playing back video/audio, we can use the same Netstreams we used to record
		 * as well as the same video.
		 * 
		 * Take special note of the bufferTime change here.  If I left it at 60 or whatever was set
		 * in the UI, the netstreams try and download that much time of video/audio before starting
		 * playback.
		 * 
		 * I think the default value on netstreams of .1 sec is really intended for playback because
		 * so many people do playback vs video recording.
		 */
		private function doRecordingPlayback():void {
			setStatus("Starting simultanious playback of recording audio and video");
			
			//onScreenVideo.attachCamera(null);
			onScreenVideo.attachNetStream(activeStream);
			//audioPlaybackVideo.attachNetStream(audioOnlyStream);
			
			// Attempt to play back the audio and video file simultaniously
			// First, adjust the buffers as this will be BAD for playback
			activeStream.bufferTime = 1;
			//audioOnlyStream.bufferTime = 1;
			
			activeStream.play(currentlyRecordedFileName);
			//activeStream.play("startrekintodarkness_vp6");
			
			//audioOnlyStream.play(currentlyRecordedFileName + "_Audio");
		}
		
		/**
		 * If for some reason someone stops the playback. I just pause the audio and
		 * video stream.  they get destroyed when we record again anyway.
		 */
		private function stopRecordingPlayback():void {
			setStatus("Stopping Recording Playback");
			
			if ( activeStream != null) {
				activeStream.close();
			}
		}
		
		public function onBWCheck(_bwCheckParams:*):void {
			trace('onBWCheck called ' + _bwCheckParams);
		}
		
		/**
		 * RED5 1.0.2 SNAPSHOT by default passes an argument here. FMS 4.5 has no argument
		 * thats why this is an optional param
		 */
		public function onBWDone(_bwDoneParams:* = null):void {
			trace('onBWDone called ' + _bwDoneParams);
		}
		
		/**
		 * A netstream callback that you will get when using FMS 4.5
		 */
		public function onTimeCoordInfo(info:Object):void {
			
		}
	}
}